unit uLagrange;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    eA: TEdit;
    lA: TLabel;
    eB: TEdit;
    lB: TLabel;
    bBerechne: TButton;
    mAusgabe: TMemo;
    bLoesche: TButton;
    procedure bBerechneClick(Sender: TObject);
    procedure bLoescheClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.bBerechneClick(Sender: TObject);
var
  a,b,g,x,y : int64;
  s         : string;

  // Herrmann, Algorithmen Arbeitsbuch, S.138
  procedure Lagrange(a,b : int64; var x,y,ggt : int64);
  var
    q,r,t,u,v : integer;
  begin
    x := 0; y := 1;
    u := 1; v := 0;
    q := a div b; r := a mod b;
    while r > 0 do
    begin
      a := b; b := r;
      t := u; u := x; x := t-q*x;
      t := v; v := y; y := t-q*y;
      q := a div b; r := a mod b;
    end;
    ggt := b;
  end;

begin
  a := StrToInt(eA.text); b := StrToInt(eB.text);

  Lagrange(a,b,x,y,g);

  s := IntToStr(g)+' = '+IntToStr(x)+'*'+IntToStr(a)+' + '+
                         IntToStr(y)+'*'+IntToStr(b);
  mAusgabe.Lines.Add(s);
end;

procedure TForm1.bLoescheClick(Sender: TObject);
begin
  mAusgabe.Clear;
end;

end.
